
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Simulation_stepsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const simulation_steps = await db.simulation_steps.create(
            {
                id: data.id || undefined,
        
        sequence_order: data.sequence_order
        ||
        null
            ,
            
        speaker: data.speaker
        ||
        null
            ,
            
        step_text: data.step_text
        ||
        null
            ,
            
        expected_response_hint: data.expected_response_hint
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await simulation_steps.setSimulation( data.simulation || null, {
            transaction,
        });
        
        await simulation_steps.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return simulation_steps;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const simulation_stepsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                sequence_order: item.sequence_order
            ||
            null
            ,
            
                speaker: item.speaker
            ||
            null
            ,
            
                step_text: item.step_text
            ||
            null
            ,
            
                expected_response_hint: item.expected_response_hint
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const simulation_steps = await db.simulation_steps.bulkCreate(simulation_stepsData, { transaction });

        // For each item created, replace relation files
        

        return simulation_steps;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const simulation_steps = await db.simulation_steps.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.sequence_order !== undefined) updatePayload.sequence_order = data.sequence_order;
        
        
        if (data.speaker !== undefined) updatePayload.speaker = data.speaker;
        
        
        if (data.step_text !== undefined) updatePayload.step_text = data.step_text;
        
        
        if (data.expected_response_hint !== undefined) updatePayload.expected_response_hint = data.expected_response_hint;
        
        
        updatePayload.updatedById = currentUser.id;

        await simulation_steps.update(updatePayload, {transaction});

        
        
        if (data.simulation !== undefined) {
            await simulation_steps.setSimulation(
              
              data.simulation,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await simulation_steps.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return simulation_steps;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const simulation_steps = await db.simulation_steps.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of simulation_steps) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of simulation_steps) {
                await record.destroy({transaction});
            }
        });


        return simulation_steps;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const simulation_steps = await db.simulation_steps.findByPk(id, options);

        await simulation_steps.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await simulation_steps.destroy({
            transaction
        });

        return simulation_steps;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const simulation_steps = await db.simulation_steps.findOne(
            { where },
            { transaction },
        );

        if (!simulation_steps) {
            return simulation_steps;
        }

        const output = simulation_steps.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.simulation = await simulation_steps.getSimulation({
            transaction
        });
        
        
        output.organizations = await simulation_steps.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.simulations,
        as: 'simulation',
        
        where: filter.simulation ? {
          [Op.or]: [
            { id: { [Op.in]: filter.simulation.split('|').map(term => Utils.uuid(term)) } },
            {
              simulation_title: {
                [Op.or]: filter.simulation.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.step_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'simulation_steps',
                        'step_text',
                        filter.step_text,
                    ),
                };
            }
            
            if (filter.expected_response_hint) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'simulation_steps',
                        'expected_response_hint',
                        filter.expected_response_hint,
                    ),
                };
            }
            

            
            

            
            if (filter.sequence_orderRange) {
                const [start, end] = filter.sequence_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sequence_order: {
                    ...where.sequence_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sequence_order: {
                    ...where.sequence_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.speaker) {
                where = {
                    ...where,
                speaker: filter.speaker,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.simulation_steps.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'simulation_steps',
                        'step_text',
                        query,
                    ),
                ],
            };
        }

        const records = await db.simulation_steps.findAll({
            attributes: [ 'id', 'step_text' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['step_text', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.step_text,
        }));
    }

    
};

